
-module(lecture1).
-include_lib("eqc/include/eqc.hrl").

-compile(export_all).

prop_delete() ->
    ?FORALL({I,L},
	    {int(),list(int())},
	    ?IMPLIES(no_duplicates(L),
		     not lists:member(I,lists:delete(I,L)))).

no_duplicates(L) ->
    lists:usort(L) == lists:sort(L).

ulist(Elem) ->
    ?LET(L,list(Elem),
	 lists:usort(L)).

prop_delete_misconception() ->
  fails(
    ?FORALL(L,list(int()),
      ?IMPLIES(L /= [],
        ?FORALL(I,elements(L),
          not lists:member(I,lists:delete(I,L)))))).

